// ElemArySet.cpp: CElemArySet NX̃Cve[V
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 21/Feb/2007		
//////////////////////////////////////////////////////////////////////

#pragma warning ( disable : 4786 )
#pragma warning ( disable : 4996 )

#include <fstream>
#include <iostream>
#include <vector>
#include <string>
#include <assert.h>

#include "ElemArySet.h"
#include "ElemAry_UNS.h"

using namespace field;

int CElemArySet::InitializeFromFile(const std::string& file_name, long& offset){

	while(1){
		////////////////////////////////
		std::string strElemType;
		unsigned int ID;
		{
			FILE *fp;
			const unsigned int buff_size = 512;
			char stmp1[buff_size];

			if( (fp = fopen(file_name.c_str(),"r"))== NULL ){
				std::cout << "Error!-->Cannot Open File" << std::endl;
				assert(0);
				return false;
			}

			fseek(fp,offset,SEEK_SET);

			while( 1 ){
				if( fgets(stmp1,buff_size,fp) == NULL ){ return 1; }
				if( stmp1[0] == '#' ) continue;
				if( strspn(stmp1," \n") != strlen(stmp1) ) break;
			}
			assert( strncmp(stmp1,"$$$$$$$$",6)==0 );

			while( 1 ){
				if( fgets(stmp1,buff_size,fp) == NULL ){ return -1; }
				if( stmp1[0] == '#' ) continue;
				if( strspn(stmp1," \n") != strlen(stmp1) ) break;
			}
			strElemType = stmp1;
			{
				unsigned int ipos = strElemType.find("\n");
				strElemType.erase(ipos);
			}

			{
				while( fgets(stmp1,buff_size,fp) != NULL ){
					if( stmp1[0] == '#' ) continue;
					if( strspn(stmp1," \n") != strlen(stmp1) ) break;
				}
				int tmp_id;
				sscanf(stmp1,"%d",&tmp_id);
				assert( tmp_id > 0 );
				ID = tmp_id;
			}
			fclose(fp);
		}
		////////////////////////////////

		if( strElemType == "ELEM_ARY_UNS" ){
			CElemAry_UNS* pea = new CElemAry_UNS;
			int ires =  pea->InitializeFromFile(file_name,offset);
			if( ires !=0 ){
				delete pea;
				assert( ires != 1 );	// Not EOF
				return ires;
			}
			this->m_apEA.AddObj( std::make_pair(ID,pea) );
		}
		else{
			return 1;
		}
	}

	return 0;
}