
// ElemAry_UNS.h : CElemAry_UNS NX̃C^[tF[X
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 03/04/2007		
//////////////////////////////////////////////////////////////////////

#if !defined(ELEM_ARY_SET_H)
#define ELEM_ARY_SET_H

#include "ElemAry.h"

#include "ObjSet.h"

namespace field{

class CElemArySet{
public:
	CElemArySet(){}
	~CElemArySet(){
		std::vector<unsigned int> id_ary_pea = m_apEA.GetAry_ObjID();
		for(unsigned int iid_pea=0;iid_pea<id_ary_pea.size();iid_pea++){ 
			unsigned int id_pea = id_ary_pea[iid_pea];
			assert( m_apEA.IsObjID(id_pea) );
			CElemAry* pea = m_apEA.GetObj(id_pea);
			delete pea;
		}
	}

	////////////////
	bool IsID( unsigned int id ) const{
		if( this->m_apEA.IsObjID(id) ){ return true; }
		return false;
	}
	const std::vector<unsigned int>& GetAry_ID() const { return this->m_apEA.GetAry_ObjID(); }

	////////////////
	const CElemAry& GetEA(unsigned int id_ea) const{
		assert( this->m_apEA.IsObjID(id_ea) );
		if( !this->m_apEA.IsObjID(id_ea) ) throw;
		return *m_apEA.GetObj(id_ea);
	}

	////////////////
	int InitializeFromFile(const std::string& file_name, long& offset);
	int WriteToFile(const std::string& file_name, long& offset) const {
		std::vector<unsigned int> id_ary_pea = m_apEA.GetAry_ObjID();
		for(unsigned int iid_pea=0;iid_pea<id_ary_pea.size();iid_pea++){ 
			unsigned int id_pea = id_ary_pea[iid_pea];
			assert( m_apEA.IsObjID(id_pea) );
			CElemAry* pea = m_apEA.GetObj(id_pea);
			pea->WriteToFile(file_name,offset,id_pea);
		}
		return 0;
	}
private:
	CObjSet<CElemAry*> m_apEA;
};

}

#endif