
// ElemAry_UNS.h : CElemAry_UNS NX̃C^[tF[X
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 03/04/2007		
//////////////////////////////////////////////////////////////////////

#if !defined(ELEM_ARY_UNS_H)
#define ELEM_ARY_UNS_H

#include "ElemAry.h"

namespace field{

class CElemAry_UNS : public CElemAry 
{
public:
	CElemAry_UNS(){
		nelem = 0; npoel = 0; m_pLnods = 0;
		end_ipoin = 0;
	}

	bool Init(std::string& str_elem_type, 
		const unsigned int& nelem, const unsigned int& npoel, const unsigned int* lnods );

	virtual ELEM_TYPE ElemType() const { return elem_type; }
	virtual unsigned int Size() const { return nelem; }
	virtual void GetLpoel(const unsigned int& ielem, unsigned int& nnoel, unsigned int* noel ) const{
		nnoel = npoel;
		for(unsigned int ipoel=0;ipoel<npoel;ipoel++){ noel[ipoel] = m_pLnods[ielem*npoel+ipoel]; }
	}

	// _͂ޓ_
	virtual bool MakePointSurPoint(const unsigned int& npoin, 
		unsigned int* psup_ind, unsigned int& npsup, unsigned int*& psup ) const;

	// ̂߂̊֐iv؂藣j
	virtual bool MakeEdge(unsigned int& nedge, unsigned int*& edge_ary) const;
	virtual CElemAry* MakeBoundElemAry() const;
	
	int InitializeFromFile(const std::string& file_name, long& offset);
	int WriteToFile(       const std::string& file_name, long& offset, unsigned int id) const;

private:
	bool MakePointSurElem( const unsigned int npoin, 
		unsigned int* const elsup_ind, unsigned int& nelsup, unsigned int*& elsup ) const;

	bool MakePointSurPoint(const unsigned int npoin, 
		const unsigned int* elsup_ind, const unsigned int nelsup, const unsigned int* elsup,
		unsigned int* psup_ind, unsigned int&npsup, unsigned int*& psup ) const;

	bool MakeElemSurElem(const unsigned int npoin, 
		const unsigned int* elsup_ind, const unsigned int nelsup, const unsigned int* elsup, 
		unsigned int* elsuel) const;

	bool MakeElemSurElem(unsigned int* elsuel) const;


private:
	ELEM_TYPE elem_type;
	unsigned int nelem;
	unsigned int npoel;
	unsigned int * m_pLnods;
	unsigned int end_ipoin;
};

}

#endif