// NodeAry.cpp: CNodeAry NX̃Cve[V
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 03/July/2007	
//
//////////////////////////////////////////////////////////////////////

#pragma warning ( disable : 4786 )
#pragma warning ( disable : 4996 )

#include <iostream>
#include <vector>
#include <string>

#include "NodeAry.h"

#include "../Mat/Vector_Blk.h"

using namespace field;


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CNodeAry::CNodeAry(const unsigned int id, const unsigned int size) : m_Size(size)
{
	std::cout << "	CNodeAryNX̐ : IDƃTCYƂRXgN^" << std::endl;
	m_DofSize = 0;
	m_paValue = 0;
}

CNodeAry::CNodeAry() : m_Size(0)
{
	std::cout << "	CNodeAryNX̐ : IDƃTCYƂRXgN^" << std::endl;
	m_DofSize = 0;
	m_paValue = 0;
}

CNodeAry::~CNodeAry()
{
	std::cout << "	CNodeAryNX̔j" << std::endl;

	ClearSegment();
}

bool CNodeAry::ClearSegment(){
	if( m_paValue != 0 ){ 
		delete[] m_paValue; 
		m_paValue=0; 
	}
	m_aSeg.Clear();
	return true;
}

//////////////////////////////////////////////////////////////////////
// publicȃo֐
//////////////////////////////////////////////////////////////////////

const std::vector<int> CNodeAry::AddSegment( const std::vector< std::pair<unsigned int,CNodeSeg> >& id_seg_vec, const double& value)
{
	const unsigned int ndofn_pre = m_DofSize;
	const std::vector<int>& add_id_ary = this->AddSegment(id_seg_vec);
	const unsigned int ndofn_pos = m_DofSize;
	const unsigned int ndofn_add = ndofn_pos - ndofn_pre;

	std::cout << ndofn_pre << " " << ndofn_pos << std::endl;

	const unsigned int nnode = m_Size;
	for(unsigned int inode=0;inode<nnode;inode++){
		for(unsigned int idof=0;idof<ndofn_add;idof++){
			m_paValue[inode*ndofn_pos+ndofn_pre+idof] = value;
		}
	}
	return add_id_ary;
}

const std::vector<int> CNodeAry::AddSegment( 
		const std::vector< std::pair<unsigned int,CNodeSeg> >& id_seg_vec, 
		const ls::CVector_Blk& val_vec)
{
	unsigned int ndofn_add = 0;
	for(unsigned int iseg=0;iseg<id_seg_vec.size();iseg++){
		ndofn_add += id_seg_vec[iseg].second.len;
	}
	if( val_vec.BlkVecLen() != m_Size || val_vec.BlkLen() != ndofn_add ){
		std::cout << val_vec.BlkVecLen() << " " << m_Size << std::endl;
		std::cout << "Error!-->Not Mattching" << std::endl;
		assert(0);
		std::vector<int> tmp_id_ary;
		return tmp_id_ary;
	}

	const unsigned int ndofn_pre = m_DofSize;
	const std::vector<int>& add_id_ary = this->AddSegment(id_seg_vec);
	const unsigned int ndofn_pos = m_DofSize;
	assert( ndofn_pos - ndofn_pre == ndofn_add );

	const unsigned int nnode = m_Size;
	for(unsigned int inode=0;inode<nnode;inode++){
		for(unsigned int idof=0;idof<ndofn_add;idof++){
			m_paValue[inode*ndofn_pos+ndofn_pre+idof] = val_vec.GetValue(inode,idof);
		}
	}
	return add_id_ary;
}

const std::vector<int> CNodeAry::AddSegment( const std::vector< std::pair<unsigned int,CNodeSeg> >& id_seg_vec )
{
	std::vector<int> add_id_ary;
	add_id_ary.resize(id_seg_vec.size());

	const unsigned int ndofval_begin = m_DofSize;
	unsigned int idofval0 = ndofval_begin;
	for(unsigned int iseg=0;iseg<id_seg_vec.size();iseg++){
		add_id_ary[iseg] = m_aSeg.AddObj(id_seg_vec[iseg]);
		assert( m_aSeg.IsObjID( add_id_ary[iseg] ) );
		CNodeSeg& ns = m_aSeg.GetObj( add_id_ary[iseg] );
		ns.idofval_begin = idofval0;
		idofval0 += id_seg_vec[iseg].second.len;
	}
	const unsigned int ndofval_end = idofval0;

	{
		double* paVal_old = m_paValue;
		double* paVal_new = new double [m_Size*ndofval_end];
		assert( paVal_new != 0 );
		for(unsigned int inode=0;inode<m_Size;inode++){
			for(unsigned int idofval=0;idofval<ndofval_begin;idofval++){
				paVal_new[inode*ndofval_end+idofval] = paVal_old[inode*ndofval_begin+idofval];
			}
		}
		m_DofSize = ndofval_end;
		delete[] m_paValue;
		m_paValue = paVal_new;
	}
	return add_id_ary;
}

bool CNodeAry::SetValueToNodeSegment(unsigned int id_ns, const ls::CVector_Blk& vec)
{
	if( !m_aSeg.IsObjID(id_ns) ) return false;
	const CNodeSeg& ns = m_aSeg.GetObj(id_ns);

	const unsigned int idofval_begin = ns.idofval_begin;
	const unsigned int ndofns = ns.len;
	const unsigned int nnode = this->Size();
	const unsigned int ndofval = this->m_DofSize;

	assert( vec.BlkLen() == ndofns );
	assert( vec.BlkVecLen() == nnode );

	for(unsigned int inode=0;inode<nnode;inode++){
		for(unsigned int idofns=0;idofns<ndofns;idofns++){
			m_paValue[inode*ndofval+idofval_begin+idofns] = vec.GetValue(inode,idofns);
		}
	}
	return true;
}

bool CNodeAry::AddValueToNodeSegment(unsigned int id_ns, const ls::CVector_Blk& vec, double alpha)
{
	if( !this->IsSegID(id_ns) ) return false;

	const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
	const unsigned int idofval_begin = ns.idofval_begin;
	const int ndofns = ns.len;

	const unsigned int nnode = this->Size();
	const unsigned int ndofn = m_DofSize;

	assert( vec.BlkLen() == ndofns );
	assert( vec.BlkVecLen() == nnode );

	for(int inode=0;inode<nnode;inode++){
		for(int idof=0;idof<ndofns;idof++){
			m_paValue[inode*ndofn+idofval_begin+idof] 
				+= alpha*vec.GetValue(inode,idof);
		}
	}
	return true;
}


bool CNodeAry::GetValueFromNodeSegment(int id_ns, ls::CVector_Blk& vec) const
{
	if( !this->IsSegID(id_ns) ) return false;

	const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
	const unsigned int idofval_begin = ns.idofval_begin;
	const int ndofns = ns.len;

	const unsigned int nnode = this->Size();
	const unsigned int ndofn = m_DofSize;

	assert( vec.BlkLen() == ndofns );
	assert( vec.BlkVecLen() == nnode );

	for(int inode=0;inode<nnode;inode++){
		for(int idof=0;idof<ndofns;idof++){
			 double val = m_paValue[inode*ndofn+idofval_begin+idof];
			 vec.SetValue(inode,idof,val);
		}
	}
	return true;
}

bool CNodeAry::WriteToFile(const std::string& file_name, long& offset) const{

	FILE *fp;

	if( (fp = fopen(file_name.c_str(),"a"))== NULL ){
		std::cout << "Error!-->Cannot Open File" << std::endl;
		assert(0);
		return false;
	}

	fprintf(fp,"$$$$$$\n");
	fprintf(fp,"NODE\n");
	fprintf(fp,"1\n");
	fprintf(fp,"%d %d\n",this->m_Size,this->m_DofSize);

	std::vector<unsigned int> id_ary_ns = this->m_aSeg.GetAry_ObjID();
	fprintf(fp,"%d\n",id_ary_ns.size());
	for(unsigned int iid_ns=0;iid_ns<id_ary_ns.size();iid_ns++){
		unsigned int id_ns = id_ary_ns[iid_ns];
		const CNodeSeg& ns = m_aSeg.GetObj(id_ns);
		fprintf(fp,"%d %d %d %s\n", iid_ns+1, id_ns, ns.len, ns.name.c_str());
	}

	const unsigned int ndofn = this->m_DofSize;
	for(unsigned int inode=0;inode<this->Size();inode++){
		fprintf(fp,"%d ",inode+1);
		for(unsigned int idofn=0;idofn<ndofn;idofn++){
			fprintf(fp,"%lf ",this->m_paValue[inode*ndofn+idofn]);
		}
		fprintf(fp,"\n");
	}

	fclose(fp);

	return true;
}

bool CNodeAry::InitializeFromFile(const std::string& file_name, long& offset){

	FILE *fp;
	const unsigned int buff_size = 512;
	char stmp1[buff_size];

	if( (fp = fopen(file_name.c_str(),"r"))== NULL ){
		std::cout << "Error!-->Cannot Open File" << std::endl;
		assert(0);
		return false;
	}

	fseek(fp,offset,SEEK_SET);

	////////////////////////////////

	// read "$$$$$$"
	while( fgets(stmp1,buff_size,fp) != NULL ){
		if( stmp1[0] == '#' ) continue;
		if( strspn(stmp1," \n") != strlen(stmp1) ) break;
	}
	assert( strncmp(stmp1,"$$$$$$$$",6)==0 );

	// read "NODE"
	while( fgets(stmp1,buff_size,fp) != NULL ){
		if( stmp1[0] == '#' ) continue;
		if( strspn(stmp1," \n") != strlen(stmp1) ) break;
	}
	assert( strncmp(stmp1,"NODE",4)==0 );

	// read id_na
	unsigned int id;
	{
		while( fgets(stmp1,buff_size,fp) != NULL ){
			if( stmp1[0] == '#' ) continue;
			if( strspn(stmp1," \n") != strlen(stmp1) ) break;
		}
		int tmp_id;
		sscanf(stmp1,"%d",&tmp_id);
		assert( tmp_id > 0 );
		id = tmp_id;
	}
		
	// read nnode, ndofna
	unsigned int nnode, ndofn;
	{
		while( fgets(stmp1,buff_size,fp) != NULL ){
			if( stmp1[0] == '#' ) continue;
			if( strspn(stmp1," \n") != strlen(stmp1) ) break;
		}
		int tmp_nnode, tmp_ndofn;
		sscanf(stmp1,"%d%d",&tmp_nnode, &tmp_ndofn);
		assert( tmp_nnode > 0 && tmp_ndofn > 0 );
		nnode = tmp_nnode;
		ndofn = tmp_ndofn;
	}

	// read nseg_na
	unsigned int nseg;
	{
		while( fgets(stmp1,buff_size,fp) != NULL ){
			if( stmp1[0] == '#' ) continue;
			if( strspn(stmp1," \n") != strlen(stmp1) ) break;
		}
		int tmp_nseg;
		sscanf(stmp1,"%d",&tmp_nseg);
		assert( tmp_nseg > 0 );
		nseg = tmp_nseg;
	}

	std::vector< std::pair<unsigned int,CNodeSeg> > pair_id_ns_ary;
	{
		while( fgets(stmp1,buff_size,fp) != NULL ){
			if( stmp1[0] == '#' ) continue;
			if( strspn(stmp1," \n") != strlen(stmp1) ) break;
		}
		int tmp_iseg, tmp_id, tmp_len;
		char tmp_name[256];
		for(int iseg=0;;iseg++){
			sscanf(stmp1,"%d%d%d%s",&tmp_iseg, &tmp_id, &tmp_len, tmp_name);
			assert( tmp_iseg-1 == iseg );
			assert( tmp_id > 0 );
			assert( tmp_len > 0 );
			pair_id_ns_ary.push_back( std::make_pair(tmp_id, CNodeSeg(tmp_len, tmp_name)) );
			if( iseg >= nseg-1 ) break;
			fgets(stmp1,buff_size,fp);
		}
	}
		
	ls::CVector_Blk val_vec(nnode,ndofn);
	{
		while( fgets(stmp1,buff_size,fp) != NULL ){
			if( stmp1[0] == '#' ) continue;
			if( strspn(stmp1," \n") != strlen(stmp1) ) break;
		}
		char *tp, *e;
		int tmp_inode;
		double dtmp1;
		for(unsigned int inode=0;;inode++){
			tp = strtok(stmp1," ");
			tmp_inode = atoi(tp);
			assert( tmp_inode-1 == inode );
			for(unsigned int idofn=0;idofn<ndofn;idofn++){
				tp = strtok(NULL," ");
				dtmp1 = strtod(tp,&e);
				assert( *e == '\0' || *e == '\n' );
				val_vec.SetValue(inode,idofn,dtmp1);
			}
			if( inode >= nnode-1 ) break;
			fgets(stmp1,buff_size,fp);
		}
	}

	offset = ftell(fp);
	fclose(fp);

	this->m_aSeg.Clear();
	if( m_paValue != 0 ) delete m_paValue;
	this->m_DofSize = 0;

	this->m_Size = nnode;
	std::vector<int> add_id_ary = this->AddSegment(pair_id_ns_ary,val_vec);

	assert( add_id_ary.size() == pair_id_ns_ary.size() );
	for(unsigned int ins=0;ins<pair_id_ns_ary.size();ins++){
		if( add_id_ary[ins] != pair_id_ns_ary[ins].first ){
			std::cout << add_id_ary[ins] <<  " " << pair_id_ns_ary[ins].first << std::endl;
			assert(0);
		}
	}

	return true;
}



////////////////////////////////////////////////////////////////
// publicȃo֐
////////////////////////////////////////////////////////////////

bool CNodeAry::IsSegID( unsigned int id_ns ) const{
	return m_aSeg.IsObjID(id_ns);
}

unsigned int CNodeAry::GetFreeSegID() const {
	return m_aSeg.GetFreeObjID();
}
