#if !defined(OBJ_SET_H)
#define OBJ_SET_H

#pragma warning( disable : 4786 )

#ifndef for
#define for if(0); else for
#endif


#include <vector>
#include <utility>

template <class T>
class CObjSet
{		
public:
	void Clear(){
		m_aIndex2ID.clear();
		m_aID2Index.clear();
		m_aObj.clear();
	}
	const T& GetObj(unsigned int id_e) const {
		const int ie = this->GetAryInd(id_e);
		assert( ie >= 0 && ie < (int)m_aObj.size() );
		return m_aObj[ie];
	}
	T& GetObj(unsigned int id_e){
		const int ie = this->GetAryInd(id_e);
		assert( ie >= 0 && ie < (int)m_aObj.size() );
		return m_aObj[ie];
	}
	int AddObj(std::pair<unsigned int,T> id_obj){
		unsigned int id1 = AddID(id_obj.first);
		assert( IsObjID(id1) );
		this->m_aObj.push_back( id_obj.second );
		assert( m_aIndex2ID.size() == m_aObj.size() );
		return id1;
	}
	bool IsObjID( unsigned int id_e ) const {
		const int ie1 = this->GetAryInd(id_e);
		if( ie1 != -1 ) return true;
		return false;
	}
	const std::vector<unsigned int>& GetAry_ObjID() const { return this->m_aIndex2ID; }
	unsigned int GetFreeObjID() const {
		if( m_aID2Index.size() == 0 )	return 1;
		for(unsigned int iid=1;iid<m_aID2Index.size();iid++){
			if( m_aID2Index[iid] == -1 )	return iid;
		}
		return m_aID2Index.size();
	}
	std::vector<unsigned int> GetFreeObjID(const unsigned int size) const {
		std::vector<unsigned int> res;
		res.resize(size);
		unsigned int isize = 0;
		assert( m_aID2Index.size() != 1 );
		if( m_aID2Index.size() == 0 ){
			for(;;){
				res[isize] = isize+1;
				isize++;
				if(isize==size) return res;
			}
		}
		for(unsigned int iid=1;iid<m_aID2Index.size();iid++){
			if( m_aID2Index[iid] == -1 ){
				res[isize] = iid;
				isize++;
				if(isize==size) return res;
			}
		}
		for(int i=0;;i++){
			res[isize] = m_aID2Index.size()+i;
			isize++;
			if(isize==size) return res;
		}
		return res;
	}
	void Reserve(unsigned int size){
		m_aIndex2ID.reserve(size);
		m_aID2Index.reserve(size+1);
		m_aObj.reserve(size);
	}
protected:
	unsigned int AddID(const int& tmp_id){
		unsigned int id1;
		if( !IsObjID( tmp_id ) && tmp_id>0 && tmp_id<255 ){
			id1 = tmp_id;
			if( m_aID2Index.size() <= id1 ){
				m_aID2Index.resize( id1+1, -1 );
				m_aID2Index[id1] = m_aIndex2ID.size();
			}
			m_aIndex2ID.push_back(id1);
			m_aID2Index[id1] = m_aIndex2ID.size()-1;
		}
		else{
			id1 = this->GetFreeObjID();
			assert( !IsObjID(id1) );
			if( m_aID2Index.size() <= id1 ){
				m_aID2Index.resize( id1+1, -1 );
				m_aID2Index[id1] = m_aIndex2ID.size();
			}
			m_aIndex2ID.push_back(id1);
			m_aID2Index[id1] = m_aIndex2ID.size()-1;
		}
		assert( IsObjID(id1) );
		return id1;
	}
	int GetAryInd(unsigned int id_e) const {
		int ie1;
		if( m_aID2Index.size() <= id_e ) ie1 = -1;
		else ie1 = m_aID2Index[id_e];
		return ie1;
	}
protected:
	std::vector<unsigned int> m_aIndex2ID;
	std::vector<unsigned int> m_aID2Index;
	std::vector<T> m_aObj;
};

#endif
