// Vec.h: CVector_Blk NX̃C^[tFCX
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 07.May.2007		
//////////////////////////////////////////////////////////////////////

#if !defined(BC_FLAG_H)
#define BC_FLAG_H

#include "Vector_Blk.h"
#include "../Field/ElemAry.h"

namespace ls {

class CBCFlag
{
public:
	CBCFlag(unsigned int nBlk, unsigned int lenBlk)
		: m_lenBlk(lenBlk), m_nBlk(nBlk){
		m_Flag = new int [m_lenBlk*m_nBlk];
		this->Clear();
	}
	~CBCFlag(){
		if( m_Flag != 0 ){ delete[] m_Flag; }
	}

	////////////////
	unsigned int LenBlk() const { return m_lenBlk; }
	unsigned int NBlk() const { return m_nBlk; }
	bool SetZeroToBCDof(CVector_Blk& vec){
		for(unsigned int iblk=0;iblk<m_nBlk;iblk++){
			for(unsigned int idofblk=0;idofblk<m_lenBlk;idofblk++){
				if( m_Flag[iblk*m_lenBlk+idofblk] == 1 ){ vec.SetValue(iblk,idofblk,0.0); }
			}
		}
		return true;
	}
	int GetBCFlag(unsigned int iblk, unsigned int idofblk) const{
		if( iblk >= m_nBlk ){ return -1; }
		if( idofblk >= m_lenBlk ){ return -1; }
		return m_Flag[iblk*m_lenBlk+idofblk];
	}

	////////////////

	// tOSăZbg
	void Clear(){
		const unsigned int ndof = m_lenBlk*m_nBlk;
		for(unsigned int idof=0;idof<ndof;idof++){ m_Flag[idof] = 0; }
	}

	// iblkԖڂ̃ubNidofblkԖڂ̎RxŒ肷
	bool SetBC(unsigned int iBlk, unsigned int iDofBlk){
		if( iBlk >= m_nBlk ){ return false; }
		if( iDofBlk >= m_lenBlk ){ return false; }
		m_Flag[iBlk*m_lenBlk+iDofBlk] = 1;
		return true;
	}

	// elem_aryɊ܂܂ߓ_SidofblkԖڂ̎RxŒ肷
	bool SetBC(const field::CElemAry& ea, unsigned int idofblk){
		if( idofblk >= m_lenBlk ) return false;
		unsigned int noel[256];
		unsigned int nnoel;
		for(unsigned int ielem=0;ielem<ea.Size();ielem++){
			ea.GetLpoel(ielem,nnoel,noel);
			for(unsigned int inoel=0;inoel<nnoel;inoel++){
				const unsigned int inode0 = noel[inoel];
				m_Flag[inode0*m_lenBlk+idofblk] = 1;
			}
		}
		return true;
	}
private:
	const unsigned int m_lenBlk;
	const unsigned int m_nBlk;
	int* m_Flag;
};

}	// end namespace 'ls'

#endif
