// MatDiaCrsFrac.cpp: CMatDiaCrsFrac NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#pragma warning( disable : 4786 )   // C4786Ȃĕ\( ߄D)٧
#define for if(0); else for

#include <cassert>
#include <iostream>
#include <vector>
#include <math.h>

#include "MatDiaFrac_BlkCrs.h"
#include "Order_Blk.h"
#include "Vector_Blk.h"
#include "ker_mat.h"

using namespace ls;

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMatDiaFrac_BlkCrs::CMatDiaFrac_BlkCrs(const unsigned int nblk_colrow, const unsigned int len_colrow)
	:CMatDia_BlkCrs(nblk_colrow,len_colrow)
{
	m_ConditionFlag = 0;
	m_DiaInd = 0;
	m_pRowLev = 0;
}

CMatDiaFrac_BlkCrs::CMatDiaFrac_BlkCrs(const CMatDia_BlkCrs& rhs)
	:CMatDia_BlkCrs(rhs.NBlkMatCol(),rhs.LenBlkCol())
{
	m_ConditionFlag = 0;
	m_DiaInd = 0;
	m_pRowLev = 0;

	CMatDia_BlkCrs::AddPattern(rhs,true);
	assert( NBlkMatRow() == NBlkMatCol() );
	assert( LenBlkRow() == LenBlkCol() );
	{	// Make m_DiaInd
		const unsigned int nblk = NBlkMatCol();
		m_DiaInd = new unsigned int [nblk];
		for(unsigned int iblk=0;iblk<nblk;iblk++){
			m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
			for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
				assert( icrs < m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[icrs];
				assert( jblk0 < NBlkMatRow() );
				if( jblk0 > iblk ){
					m_DiaInd[iblk] = icrs;
					break;
				}
			}
		}
	}
	m_valCrs_Blk = new double [m_ncrs_Blk];
	m_ConditionFlag = 2;
}

CMatDiaFrac_BlkCrs::CMatDiaFrac_BlkCrs(const unsigned int lev_fill, const CMatDia_BlkCrs& rhs)
:CMatDia_BlkCrs(rhs.NBlkMatCol(),rhs.LenBlkCol())
{	
	m_ConditionFlag = 0;
	m_DiaInd = 0;
	m_pRowLev = 0;
	if( lev_fill == 0 ){
		CMatDia_BlkCrs::AddPattern(rhs,true);
		{	// Make m_DiaInd
			const unsigned int nblk = NBlkMatCol();
			m_DiaInd = new unsigned int [nblk];
			for(unsigned int iblk=0;iblk<nblk;iblk++){
				m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
				for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
					assert( icrs < m_ncrs_Blk );
					const unsigned int jblk0 = m_rowPtr_Blk[icrs];
					assert( jblk0 < NBlkMatRow() );
					if( jblk0 > iblk ){
						m_DiaInd[iblk] = icrs;
						break;
					}
				}
			}
		}
		m_valCrs_Blk = new double [m_ncrs_Blk*rhs.LenBlkCol()*rhs.LenBlkRow()];
		m_ConditionFlag = 2;
	}
	else{
		FracInitialize(rhs);
		AddFracPtn(lev_fill);
		FracFinalize();
		assert( m_ConditionFlag == 2 );
	}
}

CMatDiaFrac_BlkCrs::CMatDiaFrac_BlkCrs(
		const unsigned int lev_fill, const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order)
:CMatDia_BlkCrs(order.NBlkTo(),rhs.LenBlkCol())
{	
	m_ConditionFlag = 0;
	m_DiaInd = 0;
	m_pRowLev = 0;
	if( lev_fill == 0 ){
		CMatDia_BlkCrs::AddPattern(rhs,order);
		{	// Make m_DiaInd
			const unsigned int nblk = NBlkMatCol();
			m_DiaInd = new unsigned int [nblk];
			for(unsigned int iblk=0;iblk<nblk;iblk++){
				m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
				for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
					assert( icrs < m_ncrs_Blk );
					const unsigned int jblk0 = m_rowPtr_Blk[icrs];
					assert( jblk0 < NBlkMatRow() );
					if( jblk0 > iblk ){
						m_DiaInd[iblk] = icrs;
						break;
					}
				}
			}
		}
		m_valCrs_Blk = new double [m_ncrs_Blk];
		m_ConditionFlag = 2;
	}
	else{
		FracInitialize(rhs,order);
		AddFracPtn(lev_fill);
		FracFinalize();
		assert( m_ConditionFlag == 2 );
	}
}

CMatDiaFrac_BlkCrs::~CMatDiaFrac_BlkCrs()
{
	if( m_DiaInd != 0 ){ delete[] m_DiaInd; }
	if( m_pRowLev != 0 ){ delete m_pRowLev; }
}

bool CMatDiaFrac_BlkCrs::Solve(CVector_Blk& vec) const 
{
	assert( NBlkMatRow() == NBlkMatCol() );

	if( LenBlkCol() == 1 ){
		for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
			double lvec_i = vec.GetValue(iblk,0);
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_DiaInd[iblk];ijcrs++){
				assert( ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<iblk );
				lvec_i -= m_valCrs_Blk[ijcrs]*vec.GetValue(jblk0,0);
			}
			vec.SetValue(iblk,0,m_valDia_Blk[iblk]*lvec_i);
		}
		for(int iblk=NBlkMatCol()-1;iblk>=0;iblk--){
			assert( (unsigned int)iblk < NBlkMatCol() );
			double lvec_i = vec.GetValue(iblk,0);
			for(unsigned int ijcrs=m_DiaInd[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0>(unsigned int)iblk && jblk0<NBlkMatRow() );
				lvec_i -=  m_valCrs_Blk[ijcrs]*vec.GetValue(jblk0,0);
			}
			vec.SetValue(iblk,0,lvec_i);
		}
	}
	else{
		const unsigned int BlkLen = LenBlkCol();
		const unsigned int BlkSize = BlkLen*BlkLen;
		double* pTmpVec = new double [BlkLen];
		for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
			for(unsigned int idof=0;idof<BlkLen;idof++){
				pTmpVec[idof] = vec.GetValue(iblk,idof);
			}
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_DiaInd[iblk];ijcrs++){
				assert( ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<iblk );
				const double* pVal_ij = &m_valCrs_Blk[ijcrs*BlkSize];
				for(unsigned int idof=0;idof<BlkLen;idof++){
					for(unsigned int jdof=0;jdof<BlkLen;jdof++){
						pTmpVec[idof] -= pVal_ij[idof*BlkLen+jdof]*vec.GetValue(jblk0,jdof);
					}
				}
			}
			const double* pVal_ii = &m_valDia_Blk[iblk*BlkSize];
			for(unsigned int idof=0;idof<BlkLen;idof++){
				double dtmp1 = 0.0;
				for(unsigned int jdof=0;jdof<BlkLen;jdof++){
					dtmp1 += pVal_ii[idof*BlkLen+jdof]*pTmpVec[jdof];
				}
				vec.SetValue(iblk,idof,dtmp1);
			}
		}
		for(int iblk=NBlkMatCol()-1;iblk>=0;iblk--){
			assert( (unsigned int)iblk < NBlkMatCol() );
			for(unsigned int idof=0;idof<BlkLen;idof++){
				pTmpVec[idof] = vec.GetValue(iblk,idof);
			}
			for(unsigned int ijcrs=m_DiaInd[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0>(unsigned int)iblk && jblk0<NBlkMatRow() );
				const double* pVal_ij = &m_valCrs_Blk[ijcrs*BlkSize];
				for(unsigned int idof=0;idof<BlkLen;idof++){
					for(unsigned int jdof=0;jdof<BlkLen;jdof++){
						pTmpVec[idof] -= pVal_ij[idof*BlkLen+jdof]*vec.GetValue(jblk0,jdof);
					}
				}
			}
			for(unsigned int idof=0;idof<BlkLen;idof++){
				vec.SetValue(iblk,idof,pTmpVec[idof]);
			}
		}
		delete[] pTmpVec;
	}
	return true;
}

bool CMatDiaFrac_BlkCrs::DoILUDecomp()
{
	assert( NBlkMatRow() == NBlkMatCol() );
	assert( this->LenBlkRow() == LenBlkCol() );

	const unsigned int BlkLen = LenBlkCol();
	const unsigned int BlkSize = BlkLen*BlkLen;

	int info= 0;

	unsigned int* row2crs_f = new unsigned int [NBlkMatRow()];
	for(unsigned int jblk=0;jblk<NBlkMatRow();jblk++){
		row2crs_f[jblk] = -1;
	}
	if( BlkLen == 1 ){
		for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
			// [tȌ
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<NBlkMatRow() );
				row2crs_f[jblk0] = ijcrs;
			}
			// [L] * [D^-1*U] ̌vZ
			for(unsigned int ikcrs=m_colInd_Blk[iblk];ikcrs<m_colInd_Blk[iblk+1];ikcrs++){
				const unsigned int kblk = m_rowPtr_Blk[ikcrs];
				assert( kblk<NBlkMatCol() );
				if( kblk >= iblk ) break;
				const double ikvalue = m_valCrs_Blk[ikcrs];
				for(unsigned int kjcrs=m_DiaInd[kblk];kjcrs<m_colInd_Blk[kblk+1];kjcrs++){
					const unsigned int jblk0 = m_rowPtr_Blk[kjcrs];
					assert( jblk0<NBlkMatRow() );
					if( jblk0 != iblk ){
						const int ijcrs0 = row2crs_f[jblk0];
						if( ijcrs0 == -1 ) continue;	// p^[ȂΖ߂
						const double kjvalue = m_valCrs_Blk[kjcrs];
						m_valCrs_Blk[ijcrs0] -= ikvalue*kjvalue;
					}
					else{
						const double kjvalue = m_valCrs_Blk[kjcrs];
						m_valDia_Blk[iblk] -= ikvalue*kjvalue;
					}
				}
			}
			// Ίp̋tvZ
			double iivalue = m_valDia_Blk[iblk];
			if( fabs(iivalue) < 1.0e-20 ){
				std::cout << "frac false" << iblk << std::endl;
				getchar();
			}
			m_valDia_Blk[iblk] = 1.0 / iivalue;
			// Ίp̋tvZďOpsɊ|
			for(unsigned int ijcrs=m_DiaInd[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				m_valCrs_Blk[ijcrs] = m_valCrs_Blk[ijcrs] * m_valDia_Blk[iblk];
			}
			// [tOƂɖ߂
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<NBlkMatRow() );
				row2crs_f[jblk0] = -1;
			}
		}	// end iblk
	}
	////////////////////////////////////////////////////////////////
	////////////////////////////////////////////////////////////////
	else{	// lenBlk > 1
		double* pTmpBlk = new double [BlkSize];
		for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
			// [tȌ
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<NBlkMatRow() );
				row2crs_f[jblk0] = ijcrs;
			}
			// isڂɂĕsB[L] * [D^-1*U] vZB
			for(unsigned int ikcrs=m_colInd_Blk[iblk];ikcrs<m_colInd_Blk[iblk+1];ikcrs++){
				const unsigned int kblk = m_rowPtr_Blk[ikcrs];
				assert( kblk<NBlkMatCol() );
				if( kblk >= iblk ) break;
				const double* pVal_ik = &m_valCrs_Blk[ikcrs*BlkSize];
				for(unsigned int kjcrs=m_DiaInd[kblk];kjcrs<m_colInd_Blk[kblk+1];kjcrs++){
					const unsigned int jblk0 = m_rowPtr_Blk[kjcrs];
					assert( jblk0<NBlkMatRow() );
					double* pVal_kj = 0;
					double* pVal_ij = 0;
					if( jblk0 != iblk ){
						const int ijcrs0 = row2crs_f[jblk0];
						if( ijcrs0 == -1 ) continue;	// p^[ȂΖ߂
						pVal_kj = &m_valCrs_Blk[kjcrs *BlkSize];
						pVal_ij = &m_valCrs_Blk[ijcrs0*BlkSize];
					}
					else{
						pVal_kj = &m_valCrs_Blk[kjcrs*BlkSize];
						pVal_ij = &m_valDia_Blk[iblk *BlkSize];
					}
					assert( pVal_kj != 0 );
					assert( pVal_ij != 0 );
					for(unsigned int i=0;i<BlkLen;i++){
					for(unsigned int j=0;j<BlkLen;j++){
					for(unsigned int k=0;k<BlkLen;k++){
						pVal_ij[i*BlkLen+j] -= pVal_ik[i*BlkLen+k]*pVal_kj[k*BlkLen+j];
					}
					}
					}
				}
			}
			// Ίp̋tvZ
			{
				double* pVal_ii = &m_valDia_Blk[iblk*BlkSize];
				int info = 0;
				CalcInvMat(pVal_ii,BlkLen,info);
				if( info==1 ){
					std::cout << "frac false" << iblk << std::endl;
					getchar();
				}
			}
			// Ίp̋tvZďOpsɊ|B[U] = [1/D][U]
			for(unsigned int ijcrs=m_DiaInd[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				double* pVal_ij = &m_valCrs_Blk[ijcrs*BlkSize];
				const double* pVal_ii = &m_valDia_Blk[iblk *BlkSize];
				for(unsigned int i=0;i<BlkSize;i++){ pTmpBlk[i] = pVal_ij[i]; }
				for(unsigned int i=0;i<BlkLen;i++){
				for(unsigned int j=0;j<BlkLen;j++){
					double dtmp0 = 0.0;
					for(unsigned int k=0;k<BlkLen;k++){
						dtmp0 += pVal_ii[i*BlkLen+k]*pTmpBlk[k*BlkLen+j];
					}
					pVal_ij[i*BlkLen+j] = dtmp0;
				}
				}
			}
			// [tOƂɖ߂
			for(unsigned int ijcrs=m_colInd_Blk[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				assert( ijcrs>=0 && ijcrs<m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[ijcrs];
				assert( jblk0<NBlkMatRow() );
				row2crs_f[jblk0] = -1;
			}
		}	// end iblk
	}

	delete[] row2crs_f;

	return true;
}

bool CMatDiaFrac_BlkCrs::AddFracPtn(const int lev_fill)
{
	assert( NBlkMatCol() == NBlkMatRow() );

	assert( m_ConditionFlag != 0 );
	if(  m_ConditionFlag == 0 ) return false;

	if( m_ncrs_Blk == 0 ){
		std::cout << "	Dia Center " << std::endl;
		return true;
	}

	if( m_ncrs_Blk == NBlkMatCol() * ( NBlkMatRow() - 1 ) ){
		std::cout << "   Full Matrix " << std::endl;
		return true;
	}

	if( lev_fill == 0 ){
		std::cout << "    Fill Lev 0 " << std::endl;
		return true;
	}

	if( m_ConditionFlag == 2 ){

		if( m_valCrs_Blk    != 0 ){ delete[] m_valCrs_Blk;    }

		for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
			m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
			for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
				assert( icrs < m_ncrs_Blk );
				const unsigned int jblk0 = m_rowPtr_Blk[icrs];
				assert( jblk0 < NBlkMatRow() );
				if( jblk0 > iblk ){
					m_DiaInd[iblk] = icrs;
					break;
				}
			}
		}

		m_pRowLev = new std::vector<SRowLev>;
		m_pRowLev->resize( m_ncrs_Blk );
		for(unsigned int icrs=0;icrs<m_ncrs_Blk;icrs++){
			(*m_pRowLev)[icrs].row = m_rowPtr_Blk[icrs];
			(*m_pRowLev)[icrs].lev = 0;
		}
		delete[] m_rowPtr_Blk;
		m_rowPtr_Blk = 0;

		m_ConditionFlag = 1;
	}

	////////////////
	const unsigned int* ColInd_pre = m_colInd_Blk;
	const unsigned int* DiaInd_pre = m_DiaInd;
	const std::vector<SRowLev>* pRowLev_pre = m_pRowLev;

	const unsigned int ncrs_pre = m_ncrs_Blk;

	m_colInd_Blk = new unsigned int [NBlkMatCol()+1];
	m_colInd_Blk[0] = 0;
	m_DiaInd = new unsigned int [NBlkMatCol()];

	m_pRowLev = new std::vector<SRowLev>;
	m_pRowLev->reserve(ncrs_pre*4);

	std::vector<SRowLevNext> nonzero;
	nonzero.reserve(NBlkMatCol());
	for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
		{	// copy row matrix pattern
			nonzero.resize(ColInd_pre[iblk+1]-ColInd_pre[iblk]);
			unsigned int inz = 0;
			for(unsigned int ijcrs=ColInd_pre[iblk];ijcrs<ColInd_pre[iblk+1];ijcrs++){
				assert( ijcrs<ncrs_pre );
				const unsigned int jblk0 = (*pRowLev_pre)[ijcrs].row;
				assert( jblk0<NBlkMatRow() );
				const unsigned int ij_lev0 = (*pRowLev_pre)[ijcrs].lev;
				nonzero[inz].row = jblk0;
				nonzero[inz].lev = ij_lev0;
				nonzero[inz].next = inz+1;
				inz++;
			}
			nonzero[inz-1].next = -1;
		}
		int knz_cur = 0;
		for(;;){
			const unsigned int kblk0 = nonzero[knz_cur].row;
			assert( kblk0<NBlkMatCol() );
			const int ik_lev0 = nonzero[knz_cur].lev;
			if( ik_lev0+1>lev_fill && lev_fill!=-1 ){
				knz_cur = nonzero[knz_cur].next;
				if( knz_cur == -1 ) break;
				continue;
			}
			if( kblk0 >= iblk ) break;

			unsigned int jnz_cur = knz_cur;
			for(unsigned int kjcrs=m_DiaInd[kblk0];kjcrs<m_colInd_Blk[kblk0+1];kjcrs++){
				const int kj_lev0 = (*m_pRowLev)[kjcrs].lev;
				if( kj_lev0+1>lev_fill && lev_fill!=-1 ) continue;
				const int unsigned jblk0 = (*m_pRowLev)[kjcrs].row;
				assert( jblk0>kblk0 && jblk0<NBlkMatRow() );
				assert( nonzero[jnz_cur].row < jblk0 );
				if( jblk0 == iblk ) continue;

				// check if this is fill in
				bool is_fill_in = false;
				for(;;){
					const int jnz_nex = nonzero[jnz_cur].next;
					assert( (jnz_nex>=0&&jnz_nex<(int)NBlkMatRow()) || jnz_nex==-1 );
					if( jnz_nex == -1 ){ is_fill_in = true; break; }
					if( nonzero[jnz_nex].row  > jblk0 ){ is_fill_in = true; break; }
					if( nonzero[jnz_nex].row == jblk0 ){ break; }
					assert( nonzero[jnz_nex].row < jblk0 );
					jnz_cur = jnz_nex;
				}
				if( !is_fill_in ){ continue; }

				// pick up fill in
				const unsigned int max_lev0 = ( ik_lev0 > kj_lev0 ) ? ik_lev0 : kj_lev0;
				const unsigned  int inz_last = nonzero.size();
				nonzero.resize( nonzero.size()+1 );
				nonzero[inz_last].row = jblk0;
				nonzero[inz_last].lev = max_lev0 + 1;
				nonzero[inz_last].next = nonzero[jnz_cur].next;
				nonzero[jnz_cur].next = inz_last;
				jnz_cur = inz_last;
			}
			knz_cur = nonzero[knz_cur].next;
			assert( (knz_cur>=0&&knz_cur<(int)NBlkMatRow()) || knz_cur==-1 );
			if( knz_cur == -1 ) break;
		}
		////////////////
		{
			if( ColInd_pre[iblk] + nonzero.size() > m_pRowLev->max_size() ){
				std::cout << "		overflow and memory reallocate in ilu frac" << std::endl;
			}
			m_pRowLev->resize( m_colInd_Blk[iblk] + nonzero.size() );
			int icrs0 = m_colInd_Blk[iblk];
			for(int inz=0;inz!=-1;inz=nonzero[inz].next){
				const unsigned int jblk = nonzero[inz].row;
				const unsigned int jlev = nonzero[inz].lev;
				assert( jblk<NBlkMatRow() );
				assert( jblk != iblk );
				(*m_pRowLev)[icrs0].row = jblk;
				(*m_pRowLev)[icrs0].lev = jlev;
				icrs0++;
			}

			m_colInd_Blk[iblk+1] = icrs0;
			m_ncrs_Blk = icrs0;
			m_DiaInd[iblk] = icrs0;
			for(unsigned  int ijcrs=m_colInd_Blk[iblk];ijcrs<m_colInd_Blk[iblk+1];ijcrs++){
				const unsigned int jblk0 = (*m_pRowLev)[ijcrs].row;
				if( jblk0 > iblk ){
					m_DiaInd[iblk] = ijcrs;
					break;
				}
			}
		}
		////////////////
	}	// end iblk

	delete[] const_cast<unsigned int*>(ColInd_pre);
	delete[] const_cast<unsigned int*>(DiaInd_pre);
	delete const_cast< std::vector<SRowLev>* >(pRowLev_pre);
	
	return true;
}

bool CMatDiaFrac_BlkCrs::FracFinalize(){
	assert( NBlkMatRow() == NBlkMatCol() );

	assert( m_ConditionFlag != 0 );
	if(  m_ConditionFlag == 0 ){
		return false;
	}

	if( m_ConditionFlag == 2 ){
		assert( m_pRowLev == 0 );
		assert( m_rowPtr_Blk != 0 );
		return true;
	}

	m_rowPtr_Blk = new unsigned int [m_ncrs_Blk];
	assert( m_pRowLev->size() == m_ncrs_Blk );
	for(unsigned int icrs=0;icrs<m_ncrs_Blk;icrs++){
		m_rowPtr_Blk[icrs] = (*m_pRowLev)[icrs].row;
	}

	delete m_pRowLev;
	m_pRowLev = 0;

	assert( m_valCrs_Blk == 0 );
	m_valCrs_Blk = new double [m_ncrs_Blk*LenBlkCol()*LenBlkRow()];

	m_ConditionFlag = 2;

	return true;
}


bool CMatDiaFrac_BlkCrs::SetValue(const CMatDia_BlkCrs& rhs)
{
	assert( NBlkMatCol() == rhs.NBlkMatCol() );
	assert( NBlkMatRow() == rhs.NBlkMatRow() );
	assert( NBlkMatRow() == NBlkMatCol() );

	if( m_ConditionFlag == 0 ){
		// make lev_fill 0 pattern
		CMatDia_BlkCrs::AddPattern(rhs,true);
		m_valCrs_Blk = new double [m_ncrs_Blk * LenBlkCol()*LenBlkRow()];
		m_ConditionFlag = 2;
	}
	else if( m_ConditionFlag == 1 ){
		FracFinalize();
	}
	CMatDia_BlkCrs::SetValue(rhs,true);
	DoILUDecomp();
	return true;
}

// ILUs
// p^[ĂȂ΂OxFill-ing
bool CMatDiaFrac_BlkCrs::SetValue(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order)
{
	assert( NBlkMatRow() == NBlkMatCol() );
	assert( rhs.NBlkMatCol() == rhs.NBlkMatRow()   );
	assert( order.NBlkFrom() == rhs.NBlkMatCol()   );
	assert( order.NBlkTo()   == this->NBlkMatCol() );

	assert( this->LenBlkCol() == this->LenBlkRow() );
	assert( rhs.LenBlkCol()   == rhs.LenBlkRow()   );
	assert( this->LenBlkCol() == rhs.LenBlkCol()   );

	if( m_ConditionFlag == 0 ){
		// make lev_fill 0 pattern
		CMatDia_BlkCrs::AddPattern(rhs,order);
		m_valCrs_Blk = new double [m_ncrs_Blk * LenBlkCol()*LenBlkRow()];
		m_ConditionFlag = 2;
	}
	else if( m_ConditionFlag == 1 ){
		FracFinalize();
	}
	CMatDia_BlkCrs::SetValue(rhs,order);
	DoILUDecomp();
	return true;
}

bool CMatDiaFrac_BlkCrs::FracInitialize(const CMatDia_BlkCrs& rhs)
{
	CMatDia_BlkCrs::AddPattern(rhs,true);

	assert( NBlkMatCol() == rhs.NBlkMatCol() );
	assert( NBlkMatRow() == rhs.NBlkMatRow() );
	assert( NBlkMatCol() == NBlkMatRow() );

	m_DiaInd = new unsigned int [NBlkMatCol()];
	for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
		m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
		for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
			assert( icrs < m_ncrs_Blk );
			const unsigned int jblk0 = m_rowPtr_Blk[icrs];
			assert( jblk0 < NBlkMatRow() );
			if( jblk0 > iblk ){
				m_DiaInd[iblk] = icrs;
				break;
			}
		}
	}

	m_pRowLev = new std::vector<SRowLev>;
	m_pRowLev->resize( m_ncrs_Blk );
	for(unsigned int icrs=0;icrs<m_ncrs_Blk;icrs++){
		(*m_pRowLev)[icrs].row = m_rowPtr_Blk[icrs];
		(*m_pRowLev)[icrs].lev = 0;
	}
	delete[] m_rowPtr_Blk;
	m_rowPtr_Blk = 0;

	m_ConditionFlag = 1;

	return true;
}

bool CMatDiaFrac_BlkCrs::FracInitialize(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order)
{
	assert( NBlkMatRow() == NBlkMatCol() );
	assert( rhs.NBlkMatCol() == rhs.NBlkMatRow()   );
	assert( order.NBlkFrom() == rhs.NBlkMatCol()   );
	assert( order.NBlkTo()   == this->NBlkMatCol() );

	assert( this->LenBlkCol() == this->LenBlkRow() );
	assert( rhs.LenBlkCol()   == rhs.LenBlkRow()   );
	assert( this->LenBlkCol() == rhs.LenBlkCol()   );

	CMatDia_BlkCrs::AddPattern(rhs,order);

	m_DiaInd = new unsigned int [NBlkMatCol()];
	for(unsigned int iblk=0;iblk<NBlkMatCol();iblk++){
		m_DiaInd[iblk] = m_colInd_Blk[iblk+1];
		for(unsigned int icrs=m_colInd_Blk[iblk];icrs<m_colInd_Blk[iblk+1];icrs++){
			assert( icrs < m_ncrs_Blk );
			const unsigned int jblk0 = m_rowPtr_Blk[icrs];
			assert( jblk0 < NBlkMatRow() );
			if( jblk0 > iblk ){
				m_DiaInd[iblk] = icrs;
				break;
			}
		}
	}

	m_pRowLev = new std::vector<SRowLev>;
	m_pRowLev->resize( m_ncrs_Blk );
	for(unsigned int icrs=0;icrs<m_ncrs_Blk;icrs++){
		(*m_pRowLev)[icrs].row = m_rowPtr_Blk[icrs];
		(*m_pRowLev)[icrs].lev = 0;
	}
	delete[] m_rowPtr_Blk;
	m_rowPtr_Blk = 0;

	m_ConditionFlag = 1;

	return true;
}
