// MatDiaFrac_BlkCrs.h : CMatDiaFrac_BlkCrs NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(MAT_DIA_FRAC_BLK_CRS_H)
#define MAT_DIA_FRAC_BLK_CRS_H

#include <vector>

#include "MatDia_BlkCrs.h"
#include "MatPrecond_Blk.h"

namespace ls{

class COrderTotal_Blk;
class CMatDiaFrac_BlkCrs : public CMatDia_BlkCrs, public CPrecond_Blk
{
public:
	CMatDiaFrac_BlkCrs(const unsigned int nblk_colrow, const unsigned int len_colrow);
	CMatDiaFrac_BlkCrs(const CMatDia_BlkCrs& rhs);
	CMatDiaFrac_BlkCrs(const unsigned int lev_fill, const CMatDia_BlkCrs& rhs);
	CMatDiaFrac_BlkCrs(const unsigned int lev_fill, const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order);
	virtual ~CMatDiaFrac_BlkCrs();

	virtual bool SetValue(const CMatDia_BlkCrs& rhs);
	virtual bool SetValue(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order);

	virtual bool AddFracPtn(const int lev_fill);
	
	virtual bool FracInitialize(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order);
	virtual bool FracInitialize(const CMatDia_BlkCrs& rhs);
	bool FracFinalize();
	
	// Aꎟ֐
	virtual bool Solve(CVector_Blk& vec) const;

	// Aꎟ֐
	// CPrecond_BlkNXp邱ƂɂPreconditionerƂĒۉ
	virtual bool SolvePrecond(const CMatDia_BlkCrs& mat, CVector_Blk& vec) const{
		return this->Solve(vec);
	}

protected:
	// p^[Ƃ̃x\ƂɎgNX
	struct SRowLev{
		unsigned int row;
		unsigned int lev;
	};
	// p^[鎞ɎgNX
	struct SRowLevNext{
		unsigned int row;
		unsigned int lev;
		int next;
	};
private:
	// ILUs֐
	bool DoILUDecomp();

protected:
	// 0 for no pattern 
	// 1 for during pattern
	// 2 for after pattern
	unsigned int m_ConditionFlag;

	unsigned int* m_DiaInd;
	std::vector<SRowLev>* m_pRowLev;
};

}	// end namespace 'ls'

#endif // !defined(MAT_DIA_CRS_FRAC_H)
