// MatDia_Crs.h: CMatDia_BlkCrs NX̃C^[tFCX
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 02/21/2007		
//////////////////////////////////////////////////////////////////////

#if !defined(MATDIA_CRS_H)
#define MATDIA_CRS_H

#include "Mat_BlkCrs.h"

namespace field{
	class CElemAry;
}

namespace ls {

class CVector_Blk;
class CBCFlag;
class COrderTotal_Blk;

////////////////////////////////////////////////////////////////
// ΊpsNX
class CMatDia_BlkCrs  : public CMat_BlkCrs
{
public:
	CMatDia_BlkCrs(const unsigned int nblk_colrow, const unsigned int len_colrow);
	virtual ~CMatDia_BlkCrs();

	virtual bool DeletePattern();
	bool AddPattern(const field::CElemAry& ea);
	bool AddPattern(const CMatDia_BlkCrs& rhs, const bool isnt_trans);
	bool AddPattern(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order);
	bool AddPattern(const CMat_BlkCrs& m1, const CMatDia_BlkCrs& m2, const CMat_BlkCrs& m3);

	bool SetValue(const CMatDia_BlkCrs& rhs, const bool isnt_trans);
	bool SetValue(const CMatDia_BlkCrs& rhs, const COrderTotal_Blk& order);
	bool SetValue(const CMat_BlkCrs& m1, const CMatDia_BlkCrs& m2, const CMat_BlkCrs& m3);

	virtual bool SetZero();
	virtual bool Mearge(
		unsigned int nblkel_col, const unsigned int* blkel_col,
		unsigned int nblkel_row, const unsigned int* blkel_row,
		unsigned int blksize, const double* emat, unsigned int* tmp_buffer);

	bool SetBoundaryCondition(const CBCFlag& bc_flag);

	bool MatVec(double alpha, const CVector_Blk& rhs, double beta, CVector_Blk& lhs) const;

	const double* GetPtrValDia(const unsigned int ipoin) const {
		return &m_valDia_Blk[ipoin];
	}

protected:
	double* m_valDia_Blk;
};

}	// end namespace 'ls'

#endif // MATDIA_CRS_H
