// ElemAry.h : CElemAry NX̃C^[tF[X
//
//			Copy Rights (c) Nobuyuki Umetani 2007
//          e-mail : umetani@sml.k.u-tokyo.ac.jp 
//			Last Updated 03/04/2007		
//////////////////////////////////////////////////////////////////////


#if !defined(ORDER_BLK_H)
#define ORDER_BLK_H

#pragma warning( disable : 4786 )   // C4786Ȃĕ\( ߄D)٧
#define for if(0); else for

#include "Vector_Blk.h"

#include <vector>

namespace ls{

class COrderTotal_Blk{
public:
	COrderTotal_Blk(unsigned int nblk) : m_nblk(nblk)
	{
		m_map_ary = new unsigned int [nblk];
		m_inv_map_ary = new unsigned int [nblk];
		for(unsigned int iblk=0;iblk<nblk;iblk++){
			m_map_ary[iblk] = iblk;
		}
		for(unsigned int iblk=0;iblk<nblk;iblk++){
			m_inv_map_ary[iblk] = iblk;
		}
	}
	COrderTotal_Blk(const COrderTotal_Blk& order){
		m_nblk = order.m_nblk;
		m_map_ary = new unsigned int [m_nblk];
		m_inv_map_ary = new unsigned int [m_nblk];
		for(unsigned int iblk=0;iblk<m_nblk;iblk++){
			m_map_ary[iblk] = order.m_map_ary[iblk];
		}
		for(unsigned int iblk=0;iblk<m_nblk;iblk++){
			m_inv_map_ary[iblk] = order.m_inv_map_ary[iblk];
		}
	}
	/* flag̏̏ɐߓ_ёւz */
	COrderTotal_Blk(const std::vector<unsigned int>& flag) : m_nblk(flag.size())
	{
		m_map_ary = new unsigned int [m_nblk];
		unsigned int cur_flag = 0;
		unsigned int cur_blk = 0;
		for(;;){
			for(unsigned int iblk=0;iblk<m_nblk;iblk++){
				if( flag[iblk] == cur_flag ){
					m_map_ary[iblk] = cur_blk;
					cur_blk++;
				}
			}
			cur_flag++;
			if( cur_blk == m_nblk ) break;
		}
		m_inv_map_ary = new unsigned int [m_nblk];
		for(unsigned int iblk=0;iblk<m_nblk;iblk++){
			const unsigned int iblk0 = m_map_ary[iblk];
			m_inv_map_ary[iblk0] = iblk;
		}
	}
	~COrderTotal_Blk(){
		delete[] m_map_ary;
		delete[] m_inv_map_ary;
	}
	int MappedBlk(unsigned int iblk) const {
		if( iblk >= m_nblk ){ return -1; }
		unsigned int jblk = m_map_ary[iblk];
		assert( jblk < m_nblk );
		return (int)jblk;
	}
	int InverseMappedBlk(unsigned int iblk) const {
		if( iblk >= m_nblk ){ return -1; }
		unsigned int jblk = m_inv_map_ary[iblk];
		assert( jblk < m_nblk );
		return (int)jblk;
	}

	bool IsMapped(unsigned int iblk) const { return true; }
	bool IsInverseMapped(unsigned int iblk) const { return true; }
	unsigned int NBlkFrom() const { return m_nblk; }
	unsigned int NBlkTo()   const { return m_nblk; }

	bool SetVector_Map(       const CVector_Blk& vec_from, CVector_Blk& vec_to) const {
		assert( vec_from.BlkVecLen() == m_nblk );
		assert( vec_to.BlkVecLen()   == m_nblk );
		assert(  vec_from.BlkLen() == vec_to.BlkLen() );
		const unsigned int ndofblk = vec_from.BlkLen();
		for(unsigned int i0blk=0;i0blk<m_nblk;i0blk++){
			unsigned int i1blk = m_map_ary[i0blk];
			for(unsigned int idofblk=0;idofblk<ndofblk;idofblk++){
				double val = vec_from.GetValue(i0blk,idofblk);
				vec_to.SetValue(i1blk,idofblk,val);
			}
		}
		return true;
	}
	bool SetVector_InverseMap(const CVector_Blk& vec_from, CVector_Blk& vec_to) const{
		assert( vec_from.BlkVecLen() == m_nblk );
		assert( vec_to.BlkVecLen()   == m_nblk );
		assert(  vec_from.BlkLen() == vec_to.BlkLen() );
		const unsigned int ndofblk = vec_from.BlkLen();
		for(unsigned int i0blk=0;i0blk<m_nblk;i0blk++){
			unsigned int i1blk = m_inv_map_ary[i0blk];
			for(unsigned int idofblk=0;idofblk<ndofblk;idofblk++){
				double val = vec_from.GetValue(i0blk,idofblk);
				vec_to.SetValue(i1blk,idofblk,val);
			}
		}
		return true;
	}
private:
	unsigned int m_nblk;
	unsigned int* m_map_ary;
	unsigned int* m_inv_map_ary;
};

}

#endif
